Index: admin/bloglevelupgrade.php
=========================================================
--- admin/bloglevelupgrade.php	(revision 0)
+++ admin/bloglevelupgrade.php	Mon Oct 19 14:40:30 WST 2009
@@ -0,0 +1,154 @@
+<?php /// $Id: multilangupgrade.php,v 1.15 2009/08/20 08:39:07 nicolasconnault Exp $
+      /// Create "blog" forums in each course and copy blog entries from these courses' participants in these forums
+
+require_once('../config.php');
+require_once($CFG->dirroot.'/course/lib.php');
+require_once($CFG->dirroot.'/blog/lib.php');
+require_once($CFG->dirroot.'/mod/forum/lib.php');
+require_once($CFG->libdir.'/adminlib.php');
+
+admin_externalpage_setup('bloglevelupgrade');
+$PAGE->set_generaltype('maintenance');
+
+$go = optional_param('go', 0, PARAM_BOOL);
+
+admin_externalpage_print_header();
+echo $OUTPUT->heading(get_string('bloglevelupgrade', 'admin'));
+
+$strbloglevelupgrade = get_string('bloglevelupgradeinfo', 'admin');
+
+if (!$go or !data_submitted() or !confirm_sesskey()) {   /// Print a form
+    $optionsyes = array('go'=>1, 'sesskey'=>sesskey());
+    echo $OUTPUT->confirm($strbloglevelupgrade, new moodle_url('bloglevelupgrade.php', $optionsyes), 'index.php');
+    echo $OUTPUT->footer();
+    die;
+}
+
+echo $OUTPUT->box_start();
+
+/// Turn off time limits, sometimes upgrades can be slow.
+
+@set_time_limit(0);
+@ob_implicit_flush(true);
+while(@ob_end_flush());
+
+$i = 0;
+
+// If $CFG->bloglevel is set to BLOG_GROUP_LEVEL or BLOG_COURSE_LEVEL, create a new "blog" forum in each course
+// whose enrolled students have written blog entries, copy these entries in that forum and switch off blogs at site level
+
+if ($CFG->bloglevel == BLOG_COURSE_LEVEL || $CFG->bloglevel == BLOG_GROUP_LEVEL) {
+    $pbar = new progress_bar('bloglevelupgrade', 500, true);
+
+    $bloggers = $DB->get_records_sql("SELECT userid FROM {post} WHERE module = 'blog' GROUP BY userid");
+    require_once($CFG->dirroot.'/mod/forum/lib.php');
+
+    $realuser = clone($USER);
+    $a = new object();
+    $a->userscount = 0;
+    $a->blogcount = 0;
+
+    foreach ($bloggers as $blogger) {
+        $courses = get_my_courses($blogger->userid);
+        $USER->id = $blogger->userid;
+        $blogentries = $DB->get_records('post', array('module' => 'blog', 'userid' => $blogger->userid));
+
+        foreach ($courses as $course) {
+            $forum = forum_get_course_forum($course->id, 'blog');
+            $cm = get_coursemodule_from_instance('forum', $forum->id);
+
+            if ($CFG->bloglevel == BLOG_GROUP_LEVEL && $course->groupmode != NOGROUPS) {
+                // Unless the course is set to separate groups forced, force the forum to Separate groups
+                if (!($course->groupmode == SEPARATEGROUPS && $course->groupmodeforce)) {
+                    $cm->groupmode = SEPARATEGROUPS;
+                    $DB->update_record('course_modules', $cm);
+                }
+
+                $groups = groups_get_user_groups($course->id, $blogger->userid);
+                foreach ($groups[0] as $groupid) { // [0] is for all groupings combined
+                    $a->blogcount += bloglevelupgrade_entries($blogentries, $forum, $cm, $groupid);
+                }
+            } else {
+                $a->blogcount += bloglevelupgrade_entries($blogentries, $forum, $cm);
+            }
+        }
+
+        $a->userscount = $i . '/' .  count($bloggers);
+        $pbar->update($i, count($bloggers), get_string('bloglevelupgradeprogress', 'admin', $a));
+        $i++;
+    }
+
+    $USER = clone($realuser);
+}
+
+function bloglevelupgrade_entries($blogentries, $forum, $cm, $groupid=-1) {
+    $count = 0;
+
+    $forumcontext = get_context_instance(CONTEXT_MODULE, $cm->id);
+    $sitecontext = get_context_instance(CONTEXT_SYSTEM);
+
+    foreach ($blogentries as $blogentry) {
+        $discussion = new stdClass();
+        $discussion->course = $forum->course;
+        $discussion->forum = $forum->id;
+        $discussion->name = $blogentry->subject;
+        $discussion->intro = $blogentry->summary;
+        $discussion->assessed = $forum->assessed;
+        $discussion->messageformat = $forum->introformat;
+        $discussion->messagetrust = 0;
+        $discussion->attachments = 0;
+        $discussion->mailnow = false;
+        $discussion->timemodified = $blogentry->created;
+        $discussion->itemid = null;
+        $discussion->groupid = $groupid;
+        $message = '';
+
+        $discussionid = forum_add_discussion($discussion, null, $message);
+
+        // Copy file attachment records
+        $fs = get_file_storage();
+        $files = $fs->get_area_files($sitecontext->id, 'blog_attachment', $blogentry->id);
+
+        if (!empty($files)) {
+            foreach ($files as $storedfile) {
+                $newfile = new object();
+                $newfile->filearea = 'forum_attachment';
+                $newfile->itemid = $discussion->firstpost;
+                $newfile->contextid = $forumcontext->id;
+                $fs->create_file_from_storedfile($newfile, $storedfile->get_id());
+            }
+        }
+
+        $files = $fs->get_area_files($sitecontext->id, 'blog_post', $blogentry->id);
+
+        if (!empty($files)) {
+            foreach ($files as $storedfile) {
+                $newfile = new object();
+                $newfile->filearea = 'forum_post';
+                $newfile->itemid = $discussion->firstpost;
+                $newfile->contextid = $forumcontext->id;
+                $fs->create_file_from_storedfile($newfile, $storedfile->get_id());
+            }
+        }
+        $count++;
+    }
+    return $count;
+}
+// END OF LOOP
+
+// set conversion flag - switches to new plugin automatically
+set_config('bloglevel_upgrade_complete', 1);
+// Finally switch bloglevel to 0 (disabled)
+set_config('bloglevel', 0);
+
+echo $OUTPUT->box_end();
+
+/// Rebuild course cache which might be incorrect now
+echo $OUTPUT->notification('Rebuilding course cache...', 'notifysuccess');
+rebuild_course_cache();
+echo $OUTPUT->notification('...finished', 'notifysuccess');
+
+echo $OUTPUT->continue_button('index.php');
+
+echo $OUTPUT->footer();
+die;
Index: admin/index.php
=========================================================
--- admin/index.php	(revision 1.406)
+++ admin/index.php	Thu Oct 15 09:39:03 WST 2009
@@ -385,6 +385,12 @@
     echo $OUTPUT->box(get_string('multilangupgradenotice', 'admin'), 'generalbox adminwarning');
 }
 
+// Hidden bloglevel upgrade
+$showbloglevelupgrade = ($CFG->bloglevel == BLOG_COURSE_LEVEL || $CFG->bloglevel == BLOG_GROUP_LEVEL) && empty($CFG->bloglevel_upgrade_complete);
+if ($showbloglevelupgrade) {
+    echo $OUTPUT->box(get_string('bloglevelupgradenotice', 'admin'), 'generalbox adminwarning');
+}
+
 // Alert if we are currently in maintenance mode
 if (!empty($CFG->maintenance_enabled)) {
     echo $OUTPUT->box(get_string('sitemaintenancewarning2', 'admin', "$CFG->wwwroot/$CFG->admin/settings.php?section=maintenancemode"), 'generalbox adminwarning');
Index: blocks/blog_menu/block_blog_menu.php
=========================================================
--- blocks/blog_menu/block_blog_menu.php	(revision 1.29)
+++ blocks/blog_menu/block_blog_menu.php	Thu Oct 29 10:12:38 WST 2009
@@ -70,21 +70,7 @@
         $this->content = new stdClass;
         $this->content->footer = '';
 
-        $viewblogentriesurl = blog_get_context_url();
-        $strlevel = '';
-
-        switch ($context->contextlevel) {
-            case CONTEXT_COURSE:
-                $strlevel = ($context->instanceid == SITEID) ? '' : get_string('course');
-                break;
-            case CONTEXT_MODULE:
-                $strlevel = print_context_name($context);
-                break;
-            case CONTEXT_USER:
-                $strlevel = get_string('user');
-                break;
-        }
-
+        $blogheaders = blog_get_headers();
         $canviewblogs = has_capability('moodle/blog:view', $context);
 
         /// Accessibility: markup as a list.
@@ -93,16 +79,19 @@
         $menulist = new html_list();
         $menulist->add_class('list');
 
-        if (!empty($strlevel)) {
-            $url = html_link::make($viewblogentriesurl, get_string('viewblogentries', 'blog', $strlevel));
-            $url->disableifcurrent = true;
+        if (!empty($blogheaders['strview']) && $CFG->useblogassociations) {
+            $url = html_link::make($blogheaders['url'], $blogheaders['strview']);
+            if ($blogheaders['url']->compare($PAGE->url)) {
+                $url->disabled = true;
+            }
             $menulist->add_item($OUTPUT->link($url));
         }
 
         // show View site entries link
         if ($CFG->bloglevel >= BLOG_SITE_LEVEL && $canviewblogs) {
             $viewsiteentriesurl = html_link::make($CFG->wwwroot .'/blog/index.php', get_string('viewsiteentries', 'blog'));
-            if (!$PAGE->url->param('search') && !$PAGE->url->param('tag') && !$PAGE->url->param('tagid')) {
+            if (!$PAGE->url->param('search') && !$PAGE->url->param('tag') && !$PAGE->url->param('tagid') &&
+                !$PAGE->url->param('modid') && !$PAGE->url->param('courseid') && !$PAGE->url->param('userid') && !$PAGE->url->param('entryid')) {
                 $viewsiteentriesurl->disableifcurrent = true;
             }
             $menulist->add_item($OUTPUT->link($viewsiteentriesurl));
@@ -111,30 +100,34 @@
         $output .= '';
 
         // show View my entries link
-        if ($context->contextlevel != CONTEXT_USER) {
-            $myentrieslink = html_link::make(new moodle_url($CFG->wwwroot .'/blog/index.php', array('userid' => $USER->id)), get_string('viewmyentries', 'blog'));
+        $myentrieslink = html_link::make(new moodle_url($CFG->wwwroot .'/blog/index.php', array('userid' => $USER->id)), get_string('viewmyentries', 'blog'));
-            $myentrieslink->url->params($viewblogentriesurl->params());
-            $myentrieslink->disableifcurrent = true;
+        $myentrieslink->url->params($blogheaders['url']->params());
+        $pageuserid = $PAGE->url->param('userid');
+        if (!empty($pageuserid) && $pageuserid == $USER->id) {
+            $myentrieslink->disabled = true;
+        }
+
-            $menulist->add_item($OUTPUT->link($myentrieslink));
+        $menulist->add_item($OUTPUT->link($myentrieslink));
-        }
 
-        // show Add entry link
+        // show "Add entry" or "Blog about this" link
         $sitecontext = get_context_instance(CONTEXT_SYSTEM);
         if (has_capability('moodle/blog:create', $sitecontext)) {
-            $addentrylink = html_link::make(new moodle_url($CFG->wwwroot .'/blog/edit.php', array('action' => 'add')), get_string('addnewentry', 'blog'));
-            $addentrylink->url->params($viewblogentriesurl->params());
+            $addentrylink = html_link::make(new moodle_url($CFG->wwwroot .'/blog/edit.php', array('action' => 'add')), $blogheaders['stradd']);
+            $addentrylink->url->params($blogheaders['url']->params());
             $addentrylink->disableifcurrent = true;
             $menulist->add_item($OUTPUT->link($addentrylink));
         }
 
         // Full-text search field
+        if (has_capability('moodle/blog:search', $sitecontext)) {
-        $searchform = new html_form();
-        $searchform->method = 'get';
+            $searchform = new html_form();
+            $searchform->method = 'get';
-        $searchform->url = new moodle_url($viewblogentriesurl);
+            $searchform->url = new moodle_url($blogheaders['url']);
-        $searchform->button->text = get_string('search');
-        $formcontents = $OUTPUT->field(html_field::make_text('search', '', '', 99));
+            $searchform->button->text = get_string('search');
+            $formcontents = $OUTPUT->field(html_field::make_text('search', '', '', 99));
+            $menulist->add_item($OUTPUT->form($searchform, $formcontents));
+        }
 
-        $menulist->add_item($OUTPUT->form($searchform, $formcontents));
         $this->content->text = $OUTPUT->htmllist($menulist);
     }
 }
Index: blocks/blog_recent/block_blog_recent.php
=========================================================
--- blocks/blog_recent/block_blog_recent.php	(revision 1.1)
+++ blocks/blog_recent/block_blog_recent.php	Fri Oct 16 15:17:35 WST 2009
@@ -40,73 +40,63 @@
         $this->version = 2009070900;
     }
 
-    function get_content() {
-        global $CFG, $USER, $PAGE, $DB;
+    function has_config() {
+        return true;
+    }
 
-        $this->content = new stdClass();
-        $this->content->footer = '';
+    function instance_allow_config() {
+        return true;
+    }
 
-        $tag     = optional_param('tag', null, PARAM_NOTAGS);
-        $tagid   = optional_param('tagid', null, PARAM_INT);
-        $entryid = optional_param('entryid', null, PARAM_INT);
-        $groupid = optional_param('groupid', null, PARAM_INT);
-        $search  = optional_param('search', null, PARAM_RAW);
+    function get_content() {
+        global $CFG, $USER, $PAGE, $DB, $OUTPUT;
 
-        //correct tagid if a text tag is provided as a param
-        if (!empty($tag)) {  //text tag parameter takes precedence
-            if ($tagrec = $DB->get_record_sql("SELECT * FROM {tag} WHERE name LIKE ?", array($tag))) {
-                $tagid = $tagrec->id;
-            } else {
-                unset($tagid);
+        if (empty($CFG->bloglevel) || ($CFG->bloglevel < BLOG_GLOBAL_LEVEL && !(isloggedin() && !isguestuser()))) {
+            $this->content->text = '';
+            if ($this->page->user_is_editing()) {
+                $this->content->text = get_string('blogdisable', 'blog');
             }
+            return $this->content;
         }
 
+        $this->content = new stdClass();
+        $this->content->footer = '';
+
         $context = $PAGE->get_context();
-        
+
-        $strlevel = '';
+        $blogheaders = blog_get_headers();
 
-        switch ($context->contextlevel) {
-            case CONTEXT_COURSE:
-                $strlevel = ($context->instanceid == SITEID) ? '' : get_string('course');
-                break;
-            case CONTEXT_MODULE:
-                $strlevel = print_context_name($context);
-                break;
-            case CONTEXT_USER:
-                $strlevel = get_string('user');
-                break;
+        // Remove entryid filter
+        if (!empty($blogheaders['filters']['entry'])) {
+            unset($blogheaders['filters']['entry']);
+            $blogheaders['url']->remove_params(array('entryid'));
         }
 
-        $filters = array();
+        $blogheaders['filters']['since'] = $this->config->recentbloginterval;
 
-        if (!empty($entryid)) {
-            $filters['entry'] = $entryid;
-        }
+        $bloglisting = new blog_listing($blogheaders['filters']);
+        $entries = $bloglisting->get_entries(0, $this->config->numberofrecentblogentries, 4);
 
-        if (!empty($groupid)) {
-            $filters['group'] = $groupid;
-        }
+        if (!empty($entries)) {
+            $entrieslist = new html_list();
+            $entrieslist->add_class('list');
+            $viewblogurl = new moodle_url($CFG->wwwroot . '/blog/index.php');
 
-        if (!empty($tagid)) {
-            $filters['tag'] = $tagid;
+            foreach ($entries as $entryid => $entry) {
+                $viewblogurl->param('entryid', $entryid);
+                $entrylink = html_link::make($viewblogurl, shorten_text($entry->subject));
+                $entrieslist->add_item($OUTPUT->link($entrylink));
-        }
+            }
 
-        if (!empty($search)) {
-            $filters['search'] = $search;
+            $this->content->text .= $OUTPUT->htmllist($entrieslist);
+            $strview = get_string('viewsiteentries', 'blog');
+            if (!empty($blogheaders['strview'])) {
+                $strview = $blogheaders['strview'];
-        }
+            }
-
-        $blog_listing = new blog_listing($filters);
-        $entries = $blog_listing->get_entries(0, get_user_preferences('blogrecententriesnumber', 4));
-
-        $this->content->text = '<ul class="list">';
-        $viewblog_url = $CFG->wwwroot . '/blog/index.php?entryid=';
-
-        foreach ($entries as $entry_id => $entry) {
-            $this->content->text .= "<li><a href=\"$viewblog_url$entry_id\">".shorten_text($entry->subject)."</a></li>\n";
+            $viewallentrieslink = html_link::make($blogheaders['url'], $strview);
+            $this->content->text .= $OUTPUT->link($viewallentrieslink);
+        } else {
+            $this->content->text .= get_string('norecentblogentries', 'block_blog_recent');
         }
-
-        $this->content->text .= '<li>&nbsp;</li>';
-        $this->content->text .= '<li><a href="'.blog_get_context_url().'">'.get_string('viewallblogentries', 'blog', $strlevel).'</a></li>'; 
-        $this->content->text .= '</ul>';
     }
 }
Index: blocks/blog_recent/edit_form.php
=========================================================
--- blocks/blog_recent/edit_form.php	(revision 0)
+++ blocks/blog_recent/edit_form.php	Thu Oct 15 11:30:05 WST 2009
@@ -0,0 +1,59 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Form for editing tag block instances.
+ *
+ * @package   moodlecore
+ * @copyright 2009 Tim Hunt
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Form for editing tag block instances.
+ *
+ * @copyright 2009 Tim Hunt
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class block_blog_recent_edit_form extends block_edit_form {
+    protected function specific_definition($mform) {
+        // Fields for editing HTML block title and contents.
+        $mform->addElement('header', 'configheader', get_string('blocksettings', 'block'));
+
+        $numberofentries = array();
+        for ($i = 1; $i <= 20; $i++) {
+            $numberofentries[$i] = $i;
+        }
+
+        $mform->addElement('select', 'config_numberofrecentblogentries', get_string('numentriestodisplay', 'block_blog_recent'), $numberofentries);
+        $mform->setDefault('config_numberofrecentblogentries', 4);
+
+
+        $intervals = array(
+                7200 => get_string('numhours', '', 2),
+                14400 => get_string('numhours', '', 4),
+                21600 => get_string('numhours', '', 6),
+                43200 => get_string('numhours', '', 12),
+                86400 => get_string('numhours', '', 24),
+                172800 => get_string('numdays', '', 2),
+                604800 => get_string('numdays', '', 7)
+                );
+
+        $mform->addElement('select', 'config_recentbloginterval', get_string('recentinterval', 'block_blog_recent'), $intervals);
+        $mform->setDefault('config_recentbloginterval', 86400);
+    }
+}
Index: blocks/blog_tags/block_blog_tags.php
=========================================================
--- blocks/blog_tags/block_blog_tags.php	(revision 1.43)
+++ blocks/blog_tags/block_blog_tags.php	Fri Oct 23 11:37:31 WST 2009
@@ -43,6 +43,9 @@
 
         if (empty($CFG->usetags) || empty($CFG->bloglevel)) {
             $this->content->text = '';
+            if ($this->page->user_is_editing()) {
+                $this->content->text = get_string('tagsaredisabled', 'tag');
+            }
             return $this->content;
         }
 
@@ -64,9 +67,10 @@
         $this->content->text = '';
         $this->content->footer = '';
 
-        /// Get a list of tags
+        /// Get a list of tags 
+        $timewithin = time() - $this->config->timewithin * 24 * 60 * 60; /// convert to seconds
-
+        
-        $timewithin = time() - $this->config->timewithin * 24 * 60 * 60; /// convert to seconds
+        $blogheaders = blog_get_headers();
 
         // admins should be able to read all tags
         $type = '';
@@ -75,11 +79,21 @@
         }
 
         $sql  = "SELECT t.id, t.tagtype, t.rawname, t.name, COUNT(DISTINCT ti.id) AS ct
-                   FROM {tag} t, {tag_instance} ti, {post} p
+                   FROM {tag} t, {tag_instance} ti, {post} p, {blog_association} ba
                   WHERE t.id = ti.tagid AND p.id = ti.itemid
                         $type
                         AND ti.itemtype = 'post'
-                        AND ti.timemodified > $timewithin
+                        AND ti.timemodified > $timewithin";
+
+        if (!empty($blogheaders['filters']['module'])) {
+            $modulecontext = get_context_instance(CONTEXT_MODULE, $blogheaders['filters']['module']);
+            $sql .= " AND ba.contextid = $modulecontext->id AND p.id = ba.blogid ";
+        } else if (!empty($blogheaders['filters']['course'])) {
+            $coursecontext = get_context_instance(CONTEXT_COURSE, $blogheaders['filters']['course']);
+            $sql .= " AND ba.contextid = $coursecontext->id AND p.id = ba.blogid ";
+        }
+
+        $sql .= "
                GROUP BY t.id, t.tagtype, t.name, t.rawname
                ORDER BY ct DESC, t.name ASC";
 
@@ -122,24 +136,25 @@
         /// Accessibility: markup as a list.
             $this->content->text .= "\n<ul class='inline-list'>\n";
             foreach ($etags as $tag) {
+                $blogurl = new moodle_url($CFG->wwwroot.'/blog/index.php');
+
                 switch ($CFG->bloglevel) {
                     case BLOG_USER_LEVEL:
-                        $filtertype = 'user';
-                        $filterselect = $USER->id;
+                        $blogurl->param('userid', $USER->id);
                     break;
 
                     default:
-                        if ($this->page->course->id != SITEID) {
-                            $filtertype = 'course';
-                            $filterselect = $this->page->course->id;
-                        } else {
-                            $filtertype = 'site';
-                            $filterselect = SITEID;
+                        if (!empty($blogheaders['filters']['module'])) {
+                            $blogurl->param('modid', $blogheaders['filters']['module']);
+                        } else if (!empty($blogheaders['filters']['course'])) {
+                            $blogurl->param('courseid', $blogheaders['filters']['course']);
                         }
+                        
                     break;
                 }
 
-                $link = html_link::make(blog_get_blogs_url(array($filtertype => $filterselect, 'tag'=>$tag->id)), tag_display_name($tag));
+                $blogurl->param('tagid', $tag->id);
+                $link = html_link::make($blogurl, tag_display_name($tag));
                 $link->add_class($tag->class);
                 $link->title = get_string('numberofentries','blog',$tag->ct);
                 $this->content->text .= '<li>' . $OUTPUT->link($link) . '</li> ';
